--
--@ Work Sample
--@ DIM_DIM [LSSA Modding Team]
--@ 12.12.12
--@ http://lssa.ru/
--


WorkSample = {};

function WorkSample.prerequisitesPresent(specializations)
    return true;
end;

function WorkSample:load(xmlFile)	

	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));	
		if self.hydraulics[i].punch ~= nil then
			local ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
		self.hydraulics[i].doScale = Utils.getNoNil(getXMLBool(xmlFile, hydraulicName .. "#doScale"), false);
	end;	

	local NaveskaPartXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NaveskaPart#index"));
    if NaveskaPartXNode ~= nil then
        self.NaveskaPart = {};
        self.NaveskaPart.node = NaveskaPartXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaPart#minRot"));
        self.NaveskaPart.minRot = {};
        self.NaveskaPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaPart#maxRot"));
        self.NaveskaPart.maxRot = {};
        self.NaveskaPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.NaveskaPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NaveskaPart#rotTime"), 2)/10000;
    end;
    self.NavPart = (self.NaveskaPart.minRot[1] - self.NaveskaPart.maxRot[1]) * self.NaveskaPart.rotTime;
	self.npart = self.NaveskaPart.minRot[1];
		
	local NaveskaVPartXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NaveskaVPart#index"));
    if NaveskaVPartXNode ~= nil then
        self.NaveskaVPart = {};
        self.NaveskaVPart.node = NaveskaVPartXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaVPart#minRot"));
        self.NaveskaVPart.minRot = {};
        self.NaveskaVPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaVPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaVPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaVPart#maxRot"));
        self.NaveskaVPart.maxRot = {};
        self.NaveskaVPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaVPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaVPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.NaveskaVPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NaveskaVPart#rotTime"), 2)/10000;
    end;
    self.NavVPart = (self.NaveskaVPart.minRot[1] - self.NaveskaVPart.maxRot[1]) * self.NaveskaVPart.rotTime;
	self.vpart = self.NaveskaVPart.minRot[1];
	
	local NaveskaSPartXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NaveskaSPart#index"));
    if NaveskaSPartXNode ~= nil then
        self.NaveskaSPart = {};
        self.NaveskaSPart.node = NaveskaSPartXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaSPart#minRot"));
        self.NaveskaSPart.minRot = {};
        self.NaveskaSPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaSPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaSPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaSPart#maxRot"));
        self.NaveskaSPart.maxRot = {};
        self.NaveskaSPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaSPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaSPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.NaveskaSPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NaveskaSPart#rotTime"), 2)/10000;
    end;
    self.NavSPart = (self.NaveskaSPart.maxRot[1] - self.NaveskaSPart.minRot[1]) * self.NaveskaSPart.rotTime;
	self.spart = self.NaveskaSPart.minRot[1];
	
	local NaveskaSerPartXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NaveskaSerPart#index"));
    if NaveskaSerPartXNode ~= nil then
        self.NaveskaSerPart = {};
        self.NaveskaSerPart.node = NaveskaSerPartXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaSerPart#minRot"));
        self.NaveskaSerPart.minRot = {};
        self.NaveskaSerPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaSerPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaSerPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NaveskaSerPart#maxRot"));
        self.NaveskaSerPart.maxRot = {};
        self.NaveskaSerPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NaveskaSerPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NaveskaSerPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.NaveskaSerPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NaveskaSerPart#rotTime"), 2)/10000;
    end;
    self.NavSerPart = (self.NaveskaSerPart.minRot[1] - self.NaveskaSerPart.maxRot[1]) * self.NaveskaSerPart.rotTime;
	self.serpart = self.NaveskaSerPart.minRot[1];
	
	local VerhJointXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.VerhJoint#index"));
    if VerhJointXNode ~= nil then
        self.VerhJoint = {};
        self.VerhJoint.node = VerhJointXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.VerhJoint#minRot"));
        self.VerhJoint.minRot = {};
        self.VerhJoint.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.VerhJoint.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.VerhJoint.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.VerhJoint#maxRot"));
        self.VerhJoint.maxRot = {};
        self.VerhJoint.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.VerhJoint.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.VerhJoint.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.VerhJoint.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.VerhJoint#rotTime"), 2)*1000;
        self.VerhJoint.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.VerhJoint#touchRotLimit"), 10));
    end;
	local NizJointXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NizJoint#index"));
    if NizJointXNode ~= nil then
        self.NizJoint = {};
        self.NizJoint.node = NizJointXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NizJoint#minRot"));
        self.NizJoint.minRot = {};
        self.NizJoint.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NizJoint.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NizJoint.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NizJoint#maxRot"));
        self.NizJoint.maxRot = {};
        self.NizJoint.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.NizJoint.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.NizJoint.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.NizJoint.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NizJoint#rotTime"), 2)*1000;
        self.NizJoint.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.NizJoint#touchRotLimit"), 10));
    end;

	local AttacherPartXNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.AttacherPart#index"));
    if AttacherPartXNode ~= nil then
        self.AttacherPart = {};
        self.AttacherPart.node = AttacherPartXNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.AttacherPart#minRot"));
        self.AttacherPart.minRot = {};
        self.AttacherPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.AttacherPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.AttacherPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.AttacherPart#maxRot"));
        self.AttacherPart.maxRot = {};
        self.AttacherPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.AttacherPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.AttacherPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.AttacherPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.AttacherPart#rotTime"), 2)/10000;
    end;
    self.AttacPart = (self.AttacherPart.minRot[1] - self.AttacherPart.maxRot[1]) * self.AttacherPart.rotTime;
	self.attpart = self.AttacherPart.minRot[1];
	
    self.serga = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SergaAndCruc#serga1"));
	self.cruc = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SergaAndCruc#cruc1"));	
	
	self.DSerga = false;	
	self.FunktionSerga = true;
	self.DerSerga = true;
	self.DCruc = false;	
	self.FunktionCruc = true;
	self.DerCruc = true;	
end;

function WorkSample:delete()
end;

function WorkSample:mouseEvent(posX, posY, isDown, isUp, button)
end;

function WorkSample:keyEvent(unicode, sym, modifier, isDown)

end;

function WorkSample:update(dt)	
	if self.isActive then
    	if self.isAITractorActivated then	
			if self.turnStage == 0 then
			    if self.poz < self.npart then
				    self.npart = self.npart - dt*self.NavPart*2.5;
					self.vpart = self.vpart - dt*self.NavVPart*2.5;
					self.spart = self.spart + dt*self.NavSPart*2.5;
					self.serpart = self.serpart - dt*self.NavSerPart*2.5;
					self.attpart = self.attpart - dt*self.AttacPart*2.5;
					self.NizJointMax = true;
				else
					self.NizJointMax = false;					
			    end;
			else
			    if self.poz < self.NaveskaPart.minRot[1] then
				    if self.npart < self.NaveskaPart.minRot[1] then
					    self.npart = self.npart + dt*self.NavPart*2.5;
						self.vpart = self.vpart + dt*self.NavVPart*2.5;
						self.spart = self.spart - dt*self.NavSPart*2.5;
						self.serpart = self.serpart + dt*self.NavSerPart*2.5;
						self.attpart = self.attpart + dt*self.AttacPart*2.5;
						self.VerhJointMax = true;
					else
						self.VerhJointMax = false;						
				    end;   
			    end;	
			end;		
    	elseif self.isEntered then
			if InputBinding.isPressed(InputBinding.HIDRAULIKAFEL) then	
				self.stop = false;
				self.NizJointMax = true;				
				if self.npart > self.NaveskaPart.maxRot[1] then
					self.npart = self.npart - dt*self.NavPart;
					self.vpart = self.vpart - dt*self.NavVPart;
					self.spart = self.spart + dt*self.NavSPart;
					self.serpart = self.serpart - dt*self.NavSerPart;
					self.attpart = self.attpart - dt*self.AttacPart;
				end;
					
			elseif InputBinding.isPressed(InputBinding.HIDRAULIKALE) then
				self.stop = false;
				self.VerhJointMax = true;
			    if self.npart < self.NaveskaPart.minRot[1] then
				    self.npart = self.npart + dt*self.NavPart; 
				    self.vpart = self.vpart + dt*self.NavVPart;
					self.spart = self.spart - dt*self.NavSPart;
					self.serpart = self.serpart + dt*self.NavSerPart;
					self.attpart = self.attpart + dt*self.AttacPart;
			    end;
					
			elseif InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
				self.stop = true;
				if self.npart >= self.NaveskaPart.minRot[1] then
					self.NLowNiz = true;
				else	
					self.NLowVerx = true; 
				end;  
				
			elseif self.NLowVerx then
				 if self.npart < self.NaveskaPart.minRot[1] then
					self.npart = self.npart + dt*self.NavPart*2.5;
					self.vpart = self.vpart + dt*self.NavVPart*2.5;
					self.spart = self.spart - dt*self.NavSPart*2.5;
					self.serpart = self.serpart + dt*self.NavSerPart*2.5;
					self.attpart = self.attpart + dt*self.AttacPart*2.5;
					self.VerhJointMax = true;
				end; 
				if self.npart >= self.NaveskaPart.minRot[1] then				
				  self.NLowVerx = false;
				end; 			

			elseif self.NLowNiz then			
				if self.poz < self.npart then
				    self.npart = self.npart - dt*self.NavPart*2.5;
					self.vpart = self.vpart - dt*self.NavVPart*2.5;
					self.spart = self.spart + dt*self.NavSPart*2.5;
					self.serpart = self.serpart - dt*self.NavSerPart*2.5;
					self.attpart = self.attpart - dt*self.AttacPart*2.5;
					self.NizJointMax = true;
				end; 
				if self.poz >= self.npart then
				  self.NLowNiz = false;
				end; 
			else
				self.NizJointMax = false;
				self.VerhJointMax = false;	
			end;
			
			if not self.stop then
				self.poz = self.npart; 				
			end;
		end;

		if  self.NaveskaPart ~= nil then
			setRotation(self.NaveskaPart.node, self.npart, 0, 0);
		end;
		
		if  self.NaveskaVPart ~= nil then
			setRotation(self.NaveskaVPart.node, self.vpart, 0, 0);
		end;

		if  self.NaveskaSPart ~= nil then
			setRotation(self.NaveskaSPart.node, self.spart, 0, 0);
		end;
		
		if  self.NaveskaSerPart ~= nil then
			setRotation(self.NaveskaSerPart.node, self.serpart, 0, 0);
		end;
		
		if  self.AttacherPart ~= nil then
			setRotation(self.AttacherPart.node, self.attpart, 0, 0);
		end;		
				
		local doRotate = self.VerhJointMax or self.VerhJointMin or not self.VerhJointMax
		if self.VerhJoint ~= nil and doRotate then
			local x, y, z = getRotation(self.VerhJoint.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.VerhJoint.maxRot, self.VerhJoint.minRot, 3, self.VerhJoint.rotTime, dt, not self.VerhJointMax);
			setRotation(self.VerhJoint.node,unpack(newRot));
		end;
		
		local doRotate = self.NizJointMax or self.NizJointMin or not self.NizJointMax
		if self.NizJoint ~= nil and doRotate then
			local x, y, z = getRotation(self.NizJoint.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.NizJoint.maxRot, self.NizJoint.minRot, 3, self.NizJoint.rotTime, dt, not self.NizJointMax);
			setRotation(self.NizJoint.node,unpack(newRot));
		end;			
			
		for i=1, table.getn(self.hydraulics) do
			local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
			local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
		
			setDirection(self.hydraulics[i].node, x, y, z, 0, 1, 0);
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if self.hydraulics[i].doScale then
				local xScale, yScale, zScale = getScale(self.hydraulics[i].punch);
				local newScale = yScale * (distance / self.hydraulics[i].punchDistance);
				setScale(self.hydraulics[i].punch, 1, 1, newScale);
			else
				if self.hydraulics[i].punch ~= nil then
					setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
				else
					setDirection(self.hydraulics[i].node, x, y, z, 0, 1, 0);
				end;
			end;
		end;			
	end;
	local px, py, pz = getWorldTranslation(self.serga);
	local mx, my, mz = getWorldTranslation(self.cruc);	
	local sx, sy, sz = project(px, py, pz);
	local tx, ty, tz = project(mx, my, mz);	
	if g_currentMission.player ~= nil then
		local pvx, pvy, pvz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(pvx-px, pvy-py, pvz-pz);	
		if distance < 2 then
			self.invicinity = true; 
		else
			self.invicinity = false; 
		end;
	end;	
	if self.invicinity  and self.DerSerga then
		if InputBinding.hasEvent(InputBinding.DRESSERGA)  then
			self.DSerga = not self.DSerga;
		end;						
		if self.DSerga  then
			renderText(sx, sy-0.0015, 0.02, g_i18n:getText("RemoveSerga"));
		else
			renderText(sx, sy-0.0015, 0.02, g_i18n:getText("DressSerga"));				
		end;
	end;
			
	if self.FunktionSerga then	
		if not self.DerSerga  then
			setVisibility(self.serga, false);
		else
			if self.DSerga  then
				setVisibility(self.serga, true);
			else
				setVisibility(self.serga, false);				
			end;			
		end;					
	else
		if self.DSerga  then
			setVisibility(self.serga, true);
		else
			setVisibility(self.serga, true);				
		end;
	end;
	
	if self.invicinity  and self.DerCruc then
		if InputBinding.hasEvent(InputBinding.DRESCRUC)  then
			self.DCruc = not self.DCruc;
		end;						
		if self.DCruc  then
			renderText(tx, ty-0.0015, 0.02, g_i18n:getText("RemoveCruc"));
		else
			renderText(tx, ty-0.0015, 0.02, g_i18n:getText("DressCruc"));				
		end;
	end;

	if self.FunktionCruc then	
		if not self.DerCruc  then
			setVisibility(self.cruc, false);
		else
			if self.DCruc  then
				setVisibility(self.cruc, true);
			else
				setVisibility(self.cruc, false);				
			end;			
		end;					
	else
		if self.DCruc  then
			setVisibility(self.cruc, true);
		else
			setVisibility(self.cruc, true);				
		end;
	end;
	
end;

function WorkSample:updateTick(dt)	
end;

function WorkSample:draw()	
end;

function WorkSample:onDetach()
end;

function WorkSample:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function WorkSample:attachImplement(implement)
	local jointType = implement.object.attacherJoint.jointType;
	
	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		self.DerSerga = false;
		self.FunktionCruc = true;
		self.DerCruc = true;		
	elseif jointType == Vehicle.JOINTTYPE_TRAILER then
		self.FunktionCruc = false;
		self.DerCruc = false;
		self.FunktionSerga = true;
		self.DerSerga = true;
	elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW  then
		self.FunktionSerga = false;
		self.DerSerga = false;
		self.FunktionCruc = true;
		self.DerCruc = true;
	end;	
end;

function WorkSample:detachImplement(implement, implementIndex)
	self.FunktionSerga = true;
	self.DerSerga = true;
	self.FunktionCruc = true;
	self.DerCruc = true;	
end;

function WorkSample:onAttach()
end;
 
function WorkSample:onLeave()
end;

function WorkSample:onActivate()
end;

function WorkSample:onDeactivate()
end;

function WorkSample:CarrierWorkingTime(diffTime)
end; 